//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string RsiParams = "14,45,55;15,45,55;16,45,55;17,45,55;18,45,55;19,45,55;20,45,55;21,45,55;";
extern int    RsiPrice  = PRICE_CLOSE;
extern int    RsiMethod = 2;
extern string _         = "Rsi methods : o->rsi, 1->Wilders rsi, 2->Rsx, 3->Cuttlers rsi";

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
int    periods[];
double levelsUp[];
double levelsDn[];
int    size;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
      RsiParams = StringTrimLeft(StringTrimRight(RsiParams));
      if (StringSubstr(RsiParams,StringLen(RsiParams),1) != ";")
                       RsiParams = StringConcatenate(RsiParams,";");

         //
         //
         //
         //
         //                                   
            
         int n,m,s = 0;
         int i = StringFind(RsiParams,";",s);
         while (i > 0)
         {
            string current = StringSubstr(RsiParams,s,i-s);
            if (current!=";")
            {
               size = ArraySize(periods)+1;
                      ArrayResize(periods ,size);
                      ArrayResize(levelsUp,size);
                      ArrayResize(levelsDn,size);
                        n = StringFind(current,",",0); periods[size-1]  = StrToInteger(StringSubstr(current,0,n));  m = n+1;
                        n = StringFind(current,",",m); levelsUp[size-1] = StrToDouble(StringSubstr(current,m,n-m)); m = n+1; 
                                                       levelsDn[size-1] = StrToDouble(StringSubstr(current,m,StringLen(current)-m));
            }
            s = i + 1;
            i = StringFind(RsiParams,";",s);
         }
         size = MathMin(size,10);
         
         //
         //
         //
         //
         //
         
   IndicatorShortName(getRsiName(RsiMethod)+" summed "+size);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         

   for(int i=limit; i>=0; i--)
   {
      int    sum   = 0;
      double price = iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i);
      for (int k=0; k<size; k++)
      {
         double rsi = iRsi(price,periods[k],i,k,RsiMethod);
            if (rsi > levelsUp[k]) sum += 1;
            if (rsi < levelsDn[k]) sum -= 1;
      }
      buffer0[i] = EMPTY_VALUE;
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
         if (sum== size) { buffer0[i] = 1; continue; }
         if (sum==-size) { buffer1[i] = 1; continue; }
                           buffer2[i] = 1;
   }     
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int& method)
{
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

//
//
//
//
//

double workRsi[][130];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
         
      //
      //
      //
      //
      //
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,instanceNo*2+0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,instanceNo*2+1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      //
      //
      //
      //
      //

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  

         //
         //
         //
         //
         //
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
            
      //
      //
      //
      //
      //
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   } 
}

//
//
//
//
//
//

double workSmma[][20];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}